diff -ru hurd-0.0/libstore/storeread.c hurd-0.1/libstore/storeread.c
--- hurd-0.0/libstore/storeread.c	Sat May 11 01:23:23 1996
+++ hurd-0.1/libstore/storeread.c	Thu Sep  5 10:12:38 1996
@@ -60,14 +60,14 @@
 		    if (! err)
 		      {
 			struct store_run run = {0, stat.st_size / block_size};
-			err = _store_file_create (source, block_size, &run, 1,
+			err = _store_file_create (source, 0, block_size, &run, 1,
 						  &store);
 		      }
 		  }
 		else
-		  err = store_file_create (source, &store);
+		  err = store_file_create (source, 0, &store);
 	      else
-		err = store_create (source, &store);
+		err = store_create (source, 0, 0, &store);
 	      if (err)
 		error (err, 3, "%s", arg);
 	    }
diff -ru hurd-0.0/libthreads/ChangeLog hurd-0.1/libthreads/ChangeLog
--- hurd-0.0/libthreads/ChangeLog	Sat Jul 20 15:47:42 1996
+++ hurd-0.1/libthreads/ChangeLog	Wed Sep  4 09:06:39 1996
@@ -1,3 +1,14 @@
+Wed Sep  4 09:06:09 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* Makefile (VPATH): Look in $(asm_syntax) instead of old
+	$(machine); Hurd configure now folds equivalent CPU types into
+	asm_syntax. 
+
+Thu Aug 29 12:50:37 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* i386/csw.S: Include <mach/i386/asm.h> instead of <i386/asm.h>.
+	Define ELF before inclusion.
+
 Sat Jul 20 15:47:24 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* Makefile (lndist-i386-files): Look for I386SRCS and I386HDRS in
diff -ru hurd-0.0/libthreads/Makefile hurd-0.1/libthreads/Makefile
--- hurd-0.0/libthreads/Makefile	Sat Jul 20 15:49:44 1996
+++ hurd-0.1/libthreads/Makefile	Wed Sep  4 09:07:16 1996
@@ -15,8 +15,6 @@
 #   along with this program; if not, write to the Free Software
 #   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
-# This is currently i386 specific. XXX
-
 dir := libthreads
 makemode := library
 
@@ -37,7 +35,7 @@
 installhdrs = cthreads.h rwlock.h
 installhdrsubdir = .
 
-VPATH += $(srcdir)/$(machine)
+VPATH += $(srcdir)/$(asm_syntax)
 
 include ../Makeconf
 
diff -ru hurd-0.0/libthreads/i386/csw.S hurd-0.1/libthreads/i386/csw.S
--- hurd-0.0/libthreads/i386/csw.S	Wed Oct  4 16:55:28 1995
+++ hurd-0.1/libthreads/i386/csw.S	Thu Aug 29 13:44:42 1996
@@ -26,6 +26,9 @@
 /*
  * HISTORY
  * $Log: csw.S,v $
+ * Revision 1.6  1996/08/29 17:44:42  thomas
+ * *** empty log message ***
+ *
  * Revision 1.5  1995/10/04 20:55:28  roland
  * (JUMPTARGET): New macro, versions for [PIC] and not.
  * Use it in place of EXT.
@@ -63,7 +66,8 @@
  * 	[90/02/05            dbg]
  * 
  */
-#include <i386/asm.h>
+#define ELF
+#include <mach/i386/asm.h>
 
 #ifdef	PIC
 #define	JUMPTARGET(name)	EXT(name##@PLT)
diff -ru hurd-0.0/libtrivfs/ChangeLog hurd-0.1/libtrivfs/ChangeLog
--- hurd-0.0/libtrivfs/ChangeLog	Thu Jul 18 23:35:28 1996
+++ hurd-0.1/libtrivfs/ChangeLog	Fri Aug 16 19:25:05 1996
@@ -1,3 +1,14 @@
+Fri Aug 16 19:24:45 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* migsupport.c (trivfs_end_using_protid): Only call
+	ports_port_deref if CRED is set.
+	(trivfs_end_using_control): Likewise.
+
+Thu Aug 15 16:14:33 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* io-pathconf.c (trivfs_S_io_pathconf): Implement by calling
+	underlying node.
+
 Thu Jul 18 23:14:44 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* io-reauthenticate.c (trivfs_S_io_reauthenticate): Use noinstall
diff -ru hurd-0.0/libtrivfs/io-pathconf.c hurd-0.1/libtrivfs/io-pathconf.c
--- hurd-0.0/libtrivfs/io-pathconf.c	Mon Sep 18 14:38:22 1995
+++ hurd-0.1/libtrivfs/io-pathconf.c	Thu Aug 15 16:14:21 1996
@@ -1,5 +1,5 @@
 /* 
-   Copyright (C) 1994 Free Software Foundation
+   Copyright (C) 1994, 1996 Free Software Foundation
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
@@ -24,10 +24,7 @@
 		      int name, int *val)
 {
   if (cred)
-    {
-      *val = 0;
-      return 0;
-    }
+    return io_pathconf (cred->realnode, name, val);
   else
     return EOPNOTSUPP;
 }
diff -ru hurd-0.0/libtrivfs/migsupport.c hurd-0.1/libtrivfs/migsupport.c
--- hurd-0.0/libtrivfs/migsupport.c	Fri Oct  6 17:43:55 1995
+++ hurd-0.1/libtrivfs/migsupport.c	Fri Aug 16 19:24:29 1996
@@ -1,5 +1,5 @@
 /* 
-   Copyright (C) 1994, 1995 Free Software Foundation
+   Copyright (C) 1994, 1995, 1996 Free Software Foundation
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
@@ -37,7 +37,8 @@
 void 
 trivfs_end_using_protid (struct trivfs_protid *cred)
 {
-  ports_port_deref (cred);
+  if (cred)
+    ports_port_deref (cred);
 }
 
 struct trivfs_control *
@@ -60,5 +61,6 @@
 void 
 trivfs_end_using_control (struct trivfs_control *cred)
 {
-  ports_port_deref (cred);
+  if (cred)
+    ports_port_deref (cred);
 }
diff -ru hurd-0.0/nfs/ChangeLog hurd-0.1/nfs/ChangeLog
--- hurd-0.0/nfs/ChangeLog	Wed Jul 31 13:25:17 1996
+++ hurd-0.1/nfs/ChangeLog	Tue Sep  3 14:15:35 1996
@@ -1,3 +1,193 @@
+Tue Sep  3 14:00:25 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* nfs-spec.h: Renamed from rpcsvc/nfs_prot.h.
+	* mount.c: Include "mount.h" instead of <rpcsvc/mount.h>.
+	* nfs.h: Include "nfs-spec.h" instead of <rpcsvc/nfs_prot.h>.
+	* rpcsvc/mount.h: Deleted file.
+	* rpcsvc: Deleted directory.
+	* mount.h (MOUNTPROG): Renamed from MOUNT_RPC_PROGRAM.
+	(MOUNTVERS): Renamed from MOUNT_RPC_VERSION.
+	* Makefile (RPCSVC_FILES): Deleted var.
+	(lndist, lndist-rpcsvc-files,
+	$(top_srcdir)/hurd-snap/$(dir)/rpcsvc): Deleted targets.
+	(LCLHDRS): Added mount.h and nfs-spec.h.
+
+Thu Aug 29 10:41:27 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* rpcsvc/nfs_prot.h (createmode): Spell EXCLUSIVE correctly.
+	* nfs.c (hurd_mode_to_nfs_type): New function.
+	* nfs.h (hurd_mode_to_nfs_type): New decl.
+	* ops.c (netfs_attempt_rmdir): process_wcc_stat for NP, not DIR.
+	(netfs_attempt_link): Spell netfs_validate_stat correctly. 
+	(minor, major): New macros.
+	(netfs_report_access): Don't try and return an error.
+
+	* rpc.c (conduct_rpc): Tolerate and return errors from write.
+
+	* Makefile (RPCSVC_FILES): New variable.
+	(lndist): Depend on lndist-rpcsvc-files.
+	(lndist-rpcsvc-files, $(top_srcdir)/hurd-snap/$(dir)/rpcsvc): New
+	targets. 
+
+Fri Aug 16 11:56:53 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ops.c (process_wcc_stat): New function.
+	(netfs_attempt_chown): Use process_wcc_stat instead of
+	register_fresh_stat.  Pack and unpack v3 SETATTR structure if
+	appropriate.
+	(netfs_attempt_chmod): Likewise.
+	(netfs_attempt_utimes): Likewise.
+	(netfs_attempt_set_size): Likewise.
+	(netfs_attempt_lookup): Use process_returned_stat instead of
+	register_fresh state.  Unpack v3 LOOKUP structure if appropriate.
+	(netfs_attempt_link): Likewise.
+	(verify_nonexistent): Assert that we are v2.
+	(netfs_report_access): Use NFS3PROC_ACCESS if we are v3.
+	(netfs_check_open_permissions): Use netfs_report_access.
+	(netfs_attempt_readlink): Unpack v3 READLINK structure if
+	appropriate.
+	(netfs_attempt_read): Pack and unpack v3 READ structure in
+	appropriate.  Use process_returned_stat instead of
+	register_fresh_stat. 
+	(netfs_attempt_write): Pack and unpack v3 WRITE structure in
+	appropriate.  Use process_wcc_stat instead of
+	register_fresh_stat. 
+	(netfs_attempt_create_file): Pack and unpack v3 CREATE structure
+	if appropriate.  Use process_returned_stat instead of
+	register_fresh_stat.
+	(netfs_attempt_link) [CHRDEV, BLKDEV, FIFO, SOCK]: If v3, use new
+	MKNOD call instead of CREATE with overloaded mode.
+	(netfs_attempt_link) [SYMLINK]: If pack and unpack v3 SYMLINK
+	structure if appropriate.
+	(netfs_attempt_unlink): Unpack v3 REMOVE structure if appropriate.
+	(netfs_attempt_rmdir): Unpack v3 RMDIR structure if appropriate.
+	(netfs_attempt_rename): Unpack v3 RENAME structure if appropriate.
+
+	* rpcsvc/nfs_prot.h (ACCESS3_READ, ACCESS3_LOOKUP, ACCESS3_MODIFY,
+	ACCESS3_EXTEND, ACCESS3_DELETE, ACCESS3_EXECUTE): New macros.
+
+	* ops.c (netfs_attempt_chown): Bother to read NFS error/success
+	value. 
+
+Thu Aug 15 15:24:29 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ops.c (verify_nonexistent): Don't need to lock DIR; it's already
+	locked.
+	(netfs_attempt_link): Lock DIR *before* calling verify_nonexistent.
+
+	* nfs.c (xdr_encode_fhandle) [protocol_version == 2]: Copy
+	fhandle->data, not fhandle itself.
+
+Wed Aug 14 12:33:37 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+  	* nfs.c (xdr_encode_fhandle): Second arg now a `struct fhandle *'.
+	Encode v3 fhandle if appropriate.
+	* cache.c: Include <netinet/in.h>.
+	(hash): New arg `length'.
+	(lookup_fhandle): Changed to be more like xdr_decode_* functions.
+	All callers changed.  Do the right thing for v3.
+	(recache_handle): Likewise.
+	* nfs.h (struct fhandle): New type.  
+	(struct netnode): Member `handle' is now a `struct fhandle'.  
+	(xdr_encode_fhandle): Second arg now a `struct fhandle *'.
+	(lookup_fhandle, recache_handle): Changed to be more like
+	xdr_decode_* functions. 
+
+	* rpcsvc/nfs_prot.h (enum sattr_time_how): New type.
+	* nfs.c (xdr_encode_64bit): New function.
+	(xdr_encode_sattr_mode, xdr_encode_sattr_ids,
+	xdr_encode_sattr_size, xdr_encode_sattr_times,
+	xdr_encode_create_state, xdr_encode_sattr_stat): Encode v3 sattr
+	if appropriate. 
+	(xdr_decode_fattr): Decode v3 fattr if appropriate.
+
+	* rpcsvc/nfs_prot.h (NFS_FHSIZE): Deleted macro.
+	(NFS2_FHSIZE, NFS3_FHSIZE, NFS3_COOKIEVERFSIZE, NFS3_CREATEVERFSIZE,
+	NFS3_WRITEVERFSIZE): New macros.
+	(enum ftype): Deleted NFFIFO.  Added NF2FIFO, NF3FIFO, and an
+	alias NF2BAD for NF3FIFO.
+	(NFSPROC_NULL, NFSPROC_GETATTR, NFSPROC_SETATTR,
+	NFSPROC_LOOKUP, NFSPROC_READLINK, NFSPROC_READ,
+	NFSPROC_WRITE, NFSPROC_CREATE, NFSPROC_REMOVE,
+	NFSPROC_RENAME, NFSPROC_LINK, NFSPROC_SYMLINK, NFSPROC_MKDIR,
+	NFSPROC_RMDIR, NFSPROC_READDIR): Replace with new
+	macros that take a version arg.  All users changed to use new
+	version arg. 
+	(NFS_PROTOCOL_FUNC): New macro.
+	(NFS2PROC_NULL, NFS2PROC_GETATTR, NFS2PROC_SETATTR, NFS2PROC_ROOT,
+	NFS2PROC_LOOKUP, NFS2PROC_READLINK, NFS2PROC_READ,
+	NFS2PROC_WRITECACHE, NFS2PROC_WRIT, NFS2PROC_CREATE,
+	NFS2PROC_REMOVE, NFS2PROC_RENAME, NFS2PROC_LINK, NFS2PROC_SYMLINK,
+	NFS2PROC_MKDIR, NFS2PROC_RMDIR, NFS2PROC_READDIR, NFS2PROC_STATFS,
+	NFS3PROC_NULL, NFS3PROC_GETATTR, NFS3PROC_SETATTR,
+	NFS3PROC_LOOKUP, NFS3PROC_ACCESS, NFS3PROC_READLINK,
+	NFS3PROC_READ, NFS3PROC_WRITE, NFS3PROC_CREATE, NFS3PROC_MKDIR,
+	NFS3PROC_SYMLINK, NFS3PROC_MKNOD, NFS3PROC_REMOVE, NFS3PROC_RMDIR,
+	NFS3PROC_RENAME, NFS3PROC_LINK, NFS3PROC_READDIR,
+	NFS3PROC_READDIRPLUS, NFS3PROC_FSSTAT, NFS3PROC_FSINFO,
+	NFS3PROC_PATHCONF, NFS3PROC_COMMIT): New macros.  All callers
+	appropriately changed.
+	
+	* nfs.c (nfs_error_trans): NFS_SERVERFAULT maps to EIO;
+	NFSERR_BADTYPE maps to EOPNOTSUPP.
+
+	* rpcsvc/nfs_prot.h (nfsstat, ftype, struct nfs_fh, nfs_fh, struct
+	nfstime, nfstime, struct fattr, fattr, struct sattr, sattr,
+	filename, nfspath, struct attrstat, attrstat, struct sattrargs,
+	sattrargs, struct diropargs, diropargs, struct diropokres,
+	diropokres, struct diropres, diropres, struct readlinkres,
+	readlinkres, struct readargs, readargs, struct readokres,
+	readokres, struct readres, readres, struct writeargs, writeargs,
+	struct createargs, createargs, struct renameargs, renameargs,
+	struct linkargs, linkargs, struct symlinkargs, symlinkargs,
+	nfscookie, struct readdirargs, readdirargs, struct entry, entry,
+	struct dirlist, dirlist, struct readdirres, readdirres, struct
+	statfsokres, statfsokres, struct statfsres, statfsres): Delete
+	unused types.
+	(xdr_nfsstat, xdr_ftype, xdr_nfs_fh, xdr_nfstime, xdr_fattr,
+	xdr_sattr, xdr_filename, xdr_nfspath, xdr_attrstat, xdr_sattrargs,
+	xdr_diropargs, xdr_diropokres, xdr_diropres, xdr_readlinkres,
+	xdr_readargs, xdr_readokres, xdr_readres, xdr_writeargs,
+	xdr_createargs, xdr_renameargs, xdr_linkargs, xdr_symlinkargs,
+	xdr_nfscookie, xdr_readdirargs, xdr_entry, xdr_dirlist,
+	xdr_readdirres, xdr_statfsokres, xdr_statfsres, nfsproc_null_2,
+	nfsproc_getattr_2, nfsproc_setattr_2, nfsproc_root_2,
+	nfsproc_lookup_2, nfsproc_readlink_2, rfsproc_read_2,
+	nfsproc_writecache_2, nfsproc_write_2, nfsproc_create_2,
+	nfsproc_remove_2, nfsproc_rename_2, nfsproc_link_2,
+	nfsproc_symlink_2, nfsproc_mkdir_2, nfsproc_rmdir_2,
+	nfsproc_readdir_2, nfsproc_statfs_2): Delete unused function
+	declarations. 
+
+Tue Aug 13 14:57:03 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ops.c (netfs_attempt_create_file): Sun's NFS client does not
+ 	expect NFSPROC_CREATE to be exclusive.  Accordingly, on most
+ 	servers (including ours) it isn't exclusive.  (Which, of course,
+ 	contradicts Sun's own RGC 1094, section 2.2.10.)  Which means we
+ 	have to insert our own test here to make sure the file doesn't
+	exist before attempting NFSPROC_CREATE.
+	(netfs_attempt_link): Likewise.
+	(verify_nonexistent): New function.
+
+Mon Aug 12 11:13:58 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* nfs.c (nfs_error_trans): Repair syntax.
+
+Thu Aug  8 18:48:22 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* nfs.h (protocol_version): New variable.
+	* mount.c (protocol_version): Define and initialize to `2'.
+
+	* rpcsvc/nfs_prot.h (enum nfsstat): Added new nfsv3 error codes:
+	NFSERR_XDEV, NFSERR_INVAL, NFSERR_MLINK, NFSERR_REMOTE,
+	NFSERR_BADHANDLE, NFSERR_NOT_SYNC, NFSERR_BAD_COOKIE,
+	NFSERR_NOTSUPP, NFSERR_TOOSMALL, NFSERR_SERVERFAULT,
+	NFSERR_BADTYPE, NFSERR_JUKEBOX.
+	(NFSERR_TRYLATER): New macro.
+	* nfs.c (nfs_error_trans): Understand v3 error codes if we are
+	runnnig v3.
+
 Wed Jul 31 13:25:00 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
 
 	* ops.c (netfs_attempt_statfs): Use NFSPROC_STATFS, not SETATTR to
diff -ru hurd-0.0/nfs/Makefile hurd-0.1/nfs/Makefile
--- hurd-0.0/nfs/Makefile	Thu Jun 13 09:38:58 1996
+++ hurd-0.1/nfs/Makefile	Tue Sep  3 14:15:16 1996
@@ -22,10 +22,12 @@
 makemode := server
 
 target = nfs
-LCLHDRS = nfs.h 
+LCLHDRS = nfs.h mount.h nfs-spec.h
 SRCS = ops.c rpc.c mount.c cred.c nfs.c cache.c consts.c main.c 
 OBJS = $(subst .c,.o,$(SRCS))
 
 nfs: $(OBJS) ../libports/libports.a ../libnetfs/libnetfs.a ../libfshelp/libfshelp.a ../libthreads/libthreads.a
 
 include ../Makeconf
+
+
diff -ru hurd-0.0/nfs/cache.c hurd-0.1/nfs/cache.c
--- hurd-0.0/nfs/cache.c	Tue Mar 19 12:56:54 1996
+++ hurd-0.1/nfs/cache.c	Wed Aug 14 15:33:08 1996
@@ -21,49 +21,62 @@
 #include "nfs.h"
 
 #include <string.h>
+#include <netinet/in.h>
 
 /* Hash table containing all the nodes currently active. */
 #define CACHESIZE 512
 static struct node *nodehash [CACHESIZE];
 
-/* Compute and return a hash key for NFS file handle FHANDLE. */
+/* Compute and return a hash key for NFS file handle DATA of LEN bytes. */
 static inline int
-hash (void *fhandle)
+hash (int *data, size_t len)
 {
   unsigned int h = 0;
+  char *cp = (char *)data;
   int i;
   
-  for (i = 0; i < NFS_FHSIZE; i++)
-    h += ((char *)fhandle)[i];
+  for (i = 0; i < len; i++)
+    h += cp[i];
   
   return h % CACHESIZE;
 }
 
-/* Lookup the specified file handle FHANDLE in the hash table.  If it
+/* Lookup the file handle in RPC result at P in the hash table.  If it
    is not present, initialize a new node structure and insert it into
    the hash table.  Whichever course, a new reference is generated and
-   the node is returned. */
-struct node *
-lookup_fhandle (void *fhandle)
+   the node is returned in *NPP.  Return the address in the RPC result
+   after the file handle.  */
+int *
+lookup_fhandle (int *p, struct node **npp)
 {
   struct node *np;
   struct netnode *nn;
-  int h = hash (fhandle);
+  size_t len;
+  int h;
+
+  if (protocol_version == 2)
+    len = NFS2_FHSIZE;
+  else
+    len = ntohl (*p++);
+  h = hash (p, len);
 
   spin_lock (&netfs_node_refcnt_lock);
   for (np = nodehash[h]; np; np = np->nn->hnext)
     {
-      if (bcmp (np->nn->handle, fhandle, NFS_FHSIZE) != 0)
+      if (np->nn->handle.size != len
+	  || bcmp (np->nn->handle.data, p, len) != 0)
 	continue;
       
       np->references++;
       spin_unlock (&netfs_node_refcnt_lock);
       mutex_lock (&np->lock);
-      return np;
+      *npp = np;
+      return p + len / sizeof (int);
     }
   
   nn = malloc (sizeof (struct netnode));
-  bcopy (fhandle, nn->handle, NFS_FHSIZE);
+  nn->handle.size = len;
+  bcopy (p, nn->handle.data, len);
   nn->stat_updated = 0;
   nn->dtrans = NOT_POSSIBLE;
   nn->dead_dir = 0;
@@ -79,7 +92,8 @@
 
   spin_unlock (&netfs_node_refcnt_lock);
   
-  return np;
+  *npp = np;
+  return p + len / sizeof (int);
 }
 
 /* Called by libnetfs when node NP has no more references.  (See
@@ -123,27 +137,36 @@
     }
 }
 
-/* Change the file handle used for node NP to be HANDLE.  Make sure the
-   hash table stays up to date. */
-void
-recache_handle (struct node *np, void *handle)
+/* Change the file handle used for node NP to be the handle at P.
+   Make sure the hash table stays up to date.  Return the address
+   after the hnadle. */
+int *
+recache_handle (int *p, struct node *np)
 {
   int h;
+  size_t len;
+
+  if (protocol_version == 2)
+    len = NFS2_FHSIZE;
+  else
+    len = ntohl (*p++);
   
   spin_lock (&netfs_node_refcnt_lock);
   *np->nn->hprevp = np->nn->hnext;
   if (np->nn->hnext)
     np->nn->hnext->nn->hprevp = np->nn->hprevp;
+
+  np->nn->handle.size = len;
+  bcopy (p, np->nn->handle.data, len);
   
-  bcopy (handle, np->nn->handle, NFS_FHSIZE);
-  
-  h = hash (handle);
+  h = hash (p, len);
   np->nn->hnext = nodehash[h];
   if (np->nn->hnext)
     np->nn->hnext->nn->hprevp = &np->nn->hnext;
   np->nn->hprevp = &nodehash[h];
   
   spin_unlock (&netfs_node_refcnt_lock);
+  return p + len / sizeof (int);
 }
 
 
diff -ru hurd-0.0/nfs/mount.c hurd-0.1/nfs/mount.c
--- hurd-0.0/nfs/mount.c	Tue Mar 19 13:12:43 1996
+++ hurd-0.1/nfs/mount.c	Tue Sep  3 14:03:55 1996
@@ -20,7 +20,6 @@
 
 #include "nfs.h"
 
-#include <rpcsvc/mount.h>
 #include <rpc/pmap_prot.h>
 #include <errno.h>
 #include <sys/socket.h>
@@ -29,6 +28,8 @@
 #include <netinet/in.h>
 #include <stdio.h>
 
+#include "mount.h"
+
 /* Service name for portmapper */
 char *pmap_service_name = "sunrpc";
 
@@ -59,6 +60,8 @@
 /* True iff NFS_PORT should be used even if portmapper present. */
 int nfs_port_override = 0;
 
+int protocol_version = 2;
+
 /* Set up an RPC for procedure PROCNUM for talking to the portmapper.
    Allocate storage with malloc and point *BUF at it; caller must free
    this when done.  Return the address where the args for the
@@ -174,8 +177,7 @@
     }
   
   /* Create the node for root */
-  np = lookup_fhandle (p);
-  p += NFS_FHSIZE / sizeof (int);
+  lookup_fhandle (p, &np);
   free (rpcbuf);
   mutex_unlock (&np->lock);
 
Only in hurd-0.1/nfs: mount.h
Only in hurd-0.1/nfs: nfs-spec.h
diff -ru hurd-0.0/nfs/nfs.c hurd-0.1/nfs/nfs.c
--- hurd-0.0/nfs/nfs.c	Mon Jul 29 12:35:00 1996
+++ hurd-0.1/nfs/nfs.c	Thu Aug 29 18:36:01 1996
@@ -45,9 +45,6 @@
       break;
 
     case NFREG:
-    case NFNON:
-    case NFBAD:
-    default:
       hurdmode = S_IFREG;
       break;
       
@@ -59,8 +56,31 @@
       hurdmode = S_IFSOCK;
       break;
 
-    case NFFIFO:
-      hurdmode = S_IFIFO;
+    default:
+      if (protocol_version == 2)
+	switch (type)
+	  {
+	  case NF2NON:
+	  case NF2BAD:
+	  default:
+	    hurdmode = S_IFREG;
+	    break;
+	    
+	  case NF2FIFO:
+	    hurdmode = S_IFIFO;
+	    break;
+	  }
+      else
+	switch (type)
+	  {
+	  case NF3FIFO:
+	    hurdmode = S_IFIFO;
+	    break;
+	    
+	  default:
+	    hurdmode = S_IFREG;
+	    break;
+	  }
       break;
     }
   
@@ -77,6 +97,37 @@
   return mode & 07777;
 }
 
+/* Convert a Hurd mode to an NFS type */
+int 
+hurd_mode_to_nfs_type (mode_t mode)
+{
+  switch (mode & S_IFMT)
+    {
+    case S_IFDIR:
+      return NFDIR;
+      
+    case S_IFCHR:
+    default:
+      return NFCHR;
+
+    case S_IFBLK:
+      return NFBLK;
+      
+    case S_IFREG:
+      return NFREG;
+
+    case S_IFLNK:
+      return NFLNK;
+      
+    case S_IFSOCK:
+      return NFSOCK;
+      
+    case S_IFIFO:
+      return protocol_version == 2 ? NF2FIFO : NF3FIFO;
+    }
+}
+
+
 
 /* Each of the functions on this page copies its second arg to *P,
    converting it to XDR representation along the way.  They then
@@ -84,10 +135,15 @@
 
 /* Encode an NFS file handle. */
 int *
-xdr_encode_fhandle (int *p, void *fhandle)
+xdr_encode_fhandle (int *p, struct fhandle *fhandle)
 {
-  bcopy (fhandle, p, NFS_FHSIZE);
-  return p + INTSIZE (NFS_FHSIZE);
+  if (protocol_version == 2)
+    {
+      bcopy (fhandle->data, p, NFS2_FHSIZE);
+      return p + INTSIZE (NFS2_FHSIZE);
+    }
+  else
+    return xdr_encode_data (p, fhandle->data, fhandle->size);
 }
 
 /* Encode uninterpreted bytes. */
@@ -102,6 +158,15 @@
   return p + nints;
 }
 
+/* Encode a 64 bit integer */
+int *
+xdr_encode_64bit (int *p, long long n)
+{
+  *p++ = htonl (n & 0xffffffff00000000LL >> 32);
+  *p++ = htonl (n & 0xffffffff);
+  return p;
+}
+
 /* Encode a C string. */
 int *
 xdr_encode_string (int *p, char *string)
@@ -113,14 +178,27 @@
 int *
 xdr_encode_sattr_mode (int *p, mode_t mode)
 {
-  *p++ = htonl (hurd_mode_to_nfs_mode (mode));
-  *p++ = -1;			/* uid */
-  *p++ = -1;			/* gid */
-  *p++ = -1;			/* size */
-  *p++ = -1;			/* atime secs */
-  *p++ = -1;			/* atime usecs */
-  *p++ = -1;			/* mtime secs */
-  *p++ = -1;			/* mtime usecs */
+  if (protocol_version == 2)
+    {
+      *p++ = htonl (hurd_mode_to_nfs_mode (mode));
+      *p++ = -1;			/* uid */
+      *p++ = -1;			/* gid */
+      *p++ = -1;			/* size */
+      *p++ = -1;			/* atime secs */
+      *p++ = -1;			/* atime usecs */
+      *p++ = -1;			/* mtime secs */
+      *p++ = -1;			/* mtime usecs */
+    }
+  else
+    {
+      *p++ = htonl (1);		/* set mode */
+      *p++ = htonl (hurd_mode_to_nfs_mode (mode));
+      *p++ = 0;			/* no uid */
+      *p++ = 0;			/* no gid */
+      *p++ = 0;			/* no size */
+      *p++ = DONT_CHANGE;	/* no atime */
+      *p++ = DONT_CHANGE;	/* no mtime */
+    }
   return p;
 }
 
@@ -128,14 +206,28 @@
 int *
 xdr_encode_sattr_ids (int *p, u_int uid, u_int gid)
 {
-  *p++ = -1;			/* mode */
-  *p++ = htonl (uid);
-  *p++ = htonl (gid);
-  *p++ = -1;			/* size */
-  *p++ = -1;			/* atime secs */
-  *p++ = -1;			/* atime usecs */
-  *p++ = -1;			/* mtime secs */
-  *p++ = -1;			/* mtime usecs */
+  if (protocol_version == 2)
+    {
+      *p++ = -1;			/* mode */
+      *p++ = htonl (uid);
+      *p++ = htonl (gid);
+      *p++ = -1;			/* size */
+      *p++ = -1;			/* atime secs */
+      *p++ = -1;			/* atime usecs */
+      *p++ = -1;			/* mtime secs */
+      *p++ = -1;			/* mtime usecs */
+    }
+  else
+    {
+      *p++ = 0;			/* no mode */
+      *p++ = htonl (1);		/* set uid */
+      *p++ = htonl (uid);
+      *p++ = htonl (1);		/* set gid */
+      *p++ = htonl (gid);
+      *p++ = 0;			/* no size */
+      *p++ = DONT_CHANGE;	/* no atime */
+      *p++ = DONT_CHANGE;	/* no mtime */
+    }
   return p;
 }
 
@@ -143,14 +235,27 @@
 int *
 xdr_encode_sattr_size (int *p, off_t size)
 {
-  *p++ = -1;			/* mode */
-  *p++ = -1;			/* uid */
-  *p++ = -1;			/* gid */
-  *p++ = htonl (size);
-  *p++ = -1;			/* atime secs */
-  *p++ = -1;			/* atime usecs */
-  *p++ = -1;			/* mtime secs */
-  *p++ = -1;			/* mtime secs */
+  if (protocol_version == 2)
+    {
+      *p++ = -1;			/* mode */
+      *p++ = -1;			/* uid */
+      *p++ = -1;			/* gid */
+      *p++ = htonl (size);
+      *p++ = -1;			/* atime secs */
+      *p++ = -1;			/* atime usecs */
+      *p++ = -1;			/* mtime secs */
+      *p++ = -1;			/* mtime secs */
+    }
+  else
+    {
+      *p++ = 0;			/* no mode */
+      *p++ = 0;			/* no uid */
+      *p++ = 0;			/* no gid */
+      *p++ = htonl (1);		/* size */
+      p = xdr_encode_64bit (p, size);
+      *p++ = DONT_CHANGE;	/* no atime */
+      *p++ = DONT_CHANGE;	/* no mtime */
+    }
   return p;
 }
 
@@ -158,14 +263,30 @@
 int *
 xdr_encode_sattr_times (int *p, struct timespec *atime, struct timespec *mtime)
 {
-  *p++ = -1;			/* mode */
-  *p++ = -1;			/* uid */
-  *p++ = -1;			/* gid */
-  *p++ = -1;			/* size */
-  *p++ = htonl (atime->tv_sec);
-  *p++ = htonl (atime->tv_nsec * 1000);
-  *p++ = htonl (mtime->tv_sec);
-  *p++ = htonl (mtime->tv_nsec * 1000);
+  if (protocol_version == 2)
+    {
+      *p++ = -1;			/* mode */
+      *p++ = -1;			/* uid */
+      *p++ = -1;			/* gid */
+      *p++ = -1;			/* size */
+      *p++ = htonl (atime->tv_sec);
+      *p++ = htonl (atime->tv_nsec * 1000);
+      *p++ = htonl (mtime->tv_sec);
+      *p++ = htonl (mtime->tv_nsec * 1000);
+    }
+  else
+    {
+      *p++ = 0;			/* no mode */
+      *p++ = 0;			/* no uid */
+      *p++ = 0;			/* no gid */
+      *p++ = 0;			/* no size */
+      *p++ = htonl (SET_TO_CLIENT_TIME); /* atime */
+      *p++ = htonl (atime->tv_sec);
+      *p++ = htonl (atime->tv_nsec);
+      *p++ = htonl (SET_TO_CLIENT_TIME); /* mtime */
+      *p++ = htonl (mtime->tv_sec);
+      *p++ = htonl (mtime->tv_nsec);
+    }
   return p;
 }
 
@@ -174,14 +295,28 @@
 xdr_encode_create_state (int *p, 
 			 mode_t mode)
 {
-  *p++ = htonl (hurd_mode_to_nfs_mode (mode));
-  *p++ = -1;			/* uid */
-  *p++ = -1;			/* gid */
-  *p++ = 0;			/* size */
-  *p++ = -1;			/* atime sec */
-  *p++ = -1;			/* atime usec */
-  *p++ = -1;			/* mtime sec */
-  *p++ = -1;			/* mtime usec */
+  if (protocol_version == 2)
+    {
+      *p++ = htonl (hurd_mode_to_nfs_mode (mode));
+      *p++ = -1;		/* uid */
+      *p++ = -1;		/* gid */
+      *p++ = 0;			/* size */
+      *p++ = -1;		/* atime sec */
+      *p++ = -1;		/* atime usec */
+      *p++ = -1;		/* mtime sec */
+      *p++ = -1;		/* mtime usec */
+    }
+  else
+    {
+      *p++ = htonl (1);		/* mode */
+      *p++ = htonl (hurd_mode_to_nfs_mode (mode));
+      *p++ = 0;			/* no uid */
+      *p++ = 0;			/* no gid */
+      *p++ = htonl (1);		/* set size */
+      p = xdr_encode_64bit (p, 0);
+      *p++ = htonl (SET_TO_SERVER_TIME); /* atime */
+      *p++ = htonl (SET_TO_SERVER_TIME); /* mtime */
+    }
   return p;
 }
 
@@ -190,18 +325,49 @@
 xdr_encode_sattr_stat (int *p,
 		       struct stat *st)
 {
-  *p++ = htonl (st->st_mode);
-  *p++ = htonl (st->st_uid);
-  *p++ = htonl (st->st_gid);
-  *p++ = htonl (st->st_size);
-  *p++ = htonl (st->st_atime);
-  *p++ = htonl (st->st_atime_usec);
-  *p++ = htonl (st->st_mtime);
-  *p++ = htonl (st->st_mtime_usec);
+  if (protocol_version == 2)
+    {
+      *p++ = htonl (hurd_mode_to_nfs_mode (st->st_mode));
+      *p++ = htonl (st->st_uid);
+      *p++ = htonl (st->st_gid);
+      *p++ = htonl (st->st_size);
+      *p++ = htonl (st->st_atime);
+      *p++ = htonl (st->st_atime_usec);
+      *p++ = htonl (st->st_mtime);
+      *p++ = htonl (st->st_mtime_usec);
+    }
+  else
+    {
+      *p++ = htonl (1);		/* set mode */
+      *p++ = htonl (hurd_mode_to_nfs_mode (st->st_mode));
+      *p++ = htonl (1);		/* set uid */
+      *p++ = htonl (st->st_uid);
+      *p++ = htonl (1);		/* set gid */
+      *p++ = htonl (st->st_gid);
+      *p++ = htonl (1);		/* set size */
+      p = xdr_encode_64bit (p, st->st_size);
+      *p++ = htonl (SET_TO_CLIENT_TIME); /* set atime */
+      *p++ = htonl (st->st_atime);
+      *p++ = htonl (st->st_atime_usec * 1000);
+      *p++ = htonl (SET_TO_CLIENT_TIME); /* set mtime */
+      *p++ = htonl (st->st_mtime);
+      *p++ = htonl (st->st_mtime_usec * 1000);
+    }
   return p;
 }
 
 
+/* Decode *P into a long long; return the address of the following data. */
+int *
+xdr_decode_64bit (int *p, long long *n)
+{
+  long long high, low;
+  high = ntohl (*p++);
+  low = ntohl (*p++);
+  *n = ((high & 0xffffffff) << 32) | (low & 0xffffffff);
+  return p;
+}
+
 /* Decode *P into a stat structure; return the address of the
    following data. */
 int *
@@ -215,10 +381,28 @@
   st->st_nlink = ntohl (*p++);
   st->st_uid = ntohl (*p++);
   st->st_gid = ntohl (*p++);
-  st->st_size = ntohl (*p++);
-  st->st_blksize = ntohl (*p++);
-  st->st_rdev = ntohl (*p++);
-  st->st_blocks = ntohl (*p++);
+  if (protocol_version == 2)
+    {
+      st->st_size = ntohl (*p++);
+      st->st_blksize = ntohl (*p++);
+      st->st_rdev = ntohl (*p++);
+      st->st_blocks = ntohl (*p++);
+    }
+  else
+    {
+      long long size;
+      int major, minor;
+      p = xdr_decode_64bit (p, &size);
+      st->st_size = size;
+      p = xdr_decode_64bit (p, &size);
+      st->st_blocks = size / 512;
+      st->st_blksize = read_size < write_size ? read_size : write_size;
+      major = ntohl (*p++);
+      minor = ntohl (*p++);
+/* XXX - Temporary */
+#define makedev(maj,min) ((((maj)&0xFF)<<8)+((min)&0xFF))
+      st->st_rdev = makedev (major, minor);
+    }
   st->st_fsid = ntohl (*p++);
   st->st_ino = ntohl (*p++);
   st->st_atime = ntohl (*p++);
@@ -228,6 +412,13 @@
   st->st_ctime = ntohl (*p++);
   st->st_ctime_usec = ntohl (*p++);
 
+  if (protocol_version == 3)
+    {
+      st->st_atime_usec /= 1000;
+      st->st_mtime_usec /= 1000;
+      st->st_ctime_usec /= 1000;
+    }
+
   return p;
 
 }
@@ -401,8 +592,41 @@
       return ESTALE;
 		  
     case NFSERR_WFLUSH:
-    default:
+      /* Not known in v3, but we just give EINVAL for unknown errors
+	 so it's the same. */
       return EINVAL;
+
+    default:
+      if (protocol_version == 2)
+	return EINVAL;
+      else
+	switch (error)
+	  {
+	  case NFSERR_XDEV:
+	    return EXDEV;
+	    
+	  case NFSERR_INVAL:
+	  case NFSERR_REMOTE:	/* not sure about this one */
+	  default:
+	    return EINVAL;
+	    
+	  case NFSERR_MLINK:
+	    return EMLINK;
+	    
+	  case NFSERR_NOTSUPP:
+	  case NFSERR_BADTYPE:
+	    return EOPNOTSUPP;
+
+	  case NFSERR_SERVERFAULT:
+	    return EIO;
+
+	  case NFSERR_BADHANDLE:
+	  case NFSERR_NOT_SYNC:
+	  case NFSERR_BAD_COOKIE:
+	  case NFSERR_TOOSMALL:
+	  case NFSERR_JUKEBOX:	/* ??? */
+	    /* These indicate bugs in the client, so EGRATUITOUS is right. */
+	    return EGRATUITOUS;
+	  }
     }
 }
-
diff -ru hurd-0.0/nfs/nfs.h hurd-0.1/nfs/nfs.h
--- hurd-0.0/nfs/nfs.h	Thu Jun 13 09:26:31 1996
+++ hurd-0.1/nfs/nfs.h	Tue Sep  3 14:10:04 1996
@@ -21,14 +21,23 @@
 
 #include <sys/stat.h>
 #include <sys/types.h>
-#include <rpcsvc/nfs_prot.h>
+#include "nfs-spec.h"
 #include <hurd/netfs.h>
 
+/* A file handle */
+struct fhandle
+{
+  size_t size;
+
+  /* Leave enough room for the biggest possible fhandle. */
+  char data[NFS3_FHSIZE];
+};
+
 /* One of these exists for private data needed by the client for each
    node. */
 struct netnode 
 {
-  char handle[NFS_FHSIZE];
+  struct fhandle handle;
   time_t stat_updated;
   struct node *hnext, **hprevp;
 
@@ -142,6 +151,9 @@
    portmapper. */
 extern int nfs_port_override;
 
+/* Which NFS protocol version we are using */
+extern int protocol_version;
+
 
 /* Count how many four-byte chunks it takss to hold LEN bytes. */
 #define INTSIZE(len) (((len)+3)>>2)
@@ -152,7 +164,8 @@
 int cred_has_gid (struct netcred *, gid_t);
 
 /* nfs.c */
-int *xdr_encode_fhandle (int *, void *);
+int hurd_mode_to_nfs_type (mode_t);
+int *xdr_encode_fhandle (int *, struct fhandle *);
 int *xdr_encode_data (int *, char *, size_t);
 int *xdr_encode_string (int *, char *);
 int *xdr_encode_sattr_mode (int *, mode_t);
@@ -180,5 +193,5 @@
 void rpc_receive_thread (void);
 
 /* cache.c */
-struct node *lookup_fhandle (void *);
-void recache_handle (struct node *, void *);
+int *lookup_fhandle (int *, struct node **);
+int *recache_handle (int *, struct node *);
